unit Unit1;

interface

uses
  Forms, StrUtils, ClipBrd, Dialogs, SysUtils, Controls, Classes, DateUtils, Graphics,
  Buttons, ExtCtrls, StdCtrls, ComCtrls, Menus, uTerimaSMS, uKirim, XComDrv, Registry,
  jpeg;

type
  TfUtama = class(TForm)
    Timer1: TTimer;
    TabPBook: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet3: TTabSheet;
    LvPhone: TListView;
    lvSMS: TListView;
    TabSheet4: TTabSheet;
    Label1: TLabel;
    txtNomor: TEdit;
    Label2: TLabel;
    txtPesan: TMemo;
    Label3: TLabel;
    lblSisa: TLabel;
    Label4: TLabel;
    TabSheet2: TTabSheet;
    lvPBook: TListView;
    PopupMenu1: TPopupMenu;
    PilihSemua1: TMenuItem;
    TidakPilihSemua1: TMenuItem;
    N1: TMenuItem;
    BalasSMS1: TMenuItem;
    ForwardSMS1: TMenuItem;
    HapusSMS1: TMenuItem;
    PindahkePC1: TMenuItem;
    PopupMenu2: TPopupMenu;
    KirimSMS1: TMenuItem;
    N2: TMenuItem;
    CopyNomorkeClipboard1: TMenuItem;
    CopyTanggalkeClipboard1: TMenuItem;
    CopyPesankeClipboard1: TMenuItem;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    XComm1: TXComm;
    N3: TMenuItem;
    Batasitampilan1: TMenuItem;
    Semua1: TMenuItem;
    Baru1: TMenuItem;
    Inbox1: TMenuItem;
    Draft1: TMenuItem;
    Terkirim1: TMenuItem;
    LokasidiPC: TMenuItem;
    LokasidiHP: TMenuItem;
    N4: TMenuItem;
    Memori1: TMenuItem;
    N5: TMenuItem;
    SetjenisSMS1: TMenuItem;
    Baru2: TMenuItem;
    Inbox2: TMenuItem;
    Draft2: TMenuItem;
    Terkirim2: TMenuItem;
    ListSMS: TListView;
    TabSheet5: TTabSheet;
    txtNomorCall: TEdit;
    Label9: TLabel;
    SpeedButton1: TSpeedButton;
    Panggil1: TMenuItem;
    SpeedButton2: TSpeedButton;
    cbReport: TCheckBox;
    ExportSMSterpilih1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Panel1: TPanel;
    SpeedButton3: TSpeedButton;
    Label5: TLabel;
    Label6: TLabel;
    cbPort: TComboBox;
    cbBaud: TComboBox;
    Panel2: TPanel;
    Label7: TLabel;
    Label8: TLabel;
    pbSinyal: TProgressBar;
    pbBattery: TProgressBar;
    GroupBox1: TGroupBox;
    indSMSBaru: TLabel;
    indSMSFull: TLabel;
    indPanggilan: TLabel;
    Panel3: TPanel;
    SpeedButton5: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Panel4: TPanel;
    prgbar2: TProgressBar;
    lblSMS: TLabel;
    Panel5: TPanel;
    SpeedButton10: TSpeedButton;
    cbJenisPB: TComboBox;
    prgbar: TProgressBar;
    Panel6: TPanel;
    cbSumber: TComboBox;
    SpeedButton6: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure TabPBookChange(Sender: TObject);
    procedure txtPesanChange(Sender: TObject);
    procedure VrHyperButton10Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure lvSMSSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure PilihSemua1Click(Sender: TObject);
    procedure TidakPilihSemua1Click(Sender: TObject);
    procedure BalasSMS1Click(Sender: TObject);
    procedure ForwardSMS1Click(Sender: TObject);
    procedure HapusSMS1Click(Sender: TObject);
    procedure PindahkePC1Click(Sender: TObject);
    procedure KirimSMS1Click(Sender: TObject);
    procedure CopyNomorkeClipboard1Click(Sender: TObject);
    procedure CopyTanggalkeClipboard1Click(Sender: TObject);
    procedure CopyPesankeClipboard1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure XComm1Data(Sender: TObject; const Received: Cardinal);
    procedure LokasidiPCClick(Sender: TObject);
    procedure LokasidiHPClick(Sender: TObject);
    procedure Semua1Click(Sender: TObject);
    procedure Baru1Click(Sender: TObject);
    procedure Inbox1Click(Sender: TObject);
    procedure Draft1Click(Sender: TObject);
    procedure Terkirim1Click(Sender: TObject);
    procedure Baru2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Panggil1Click(Sender: TObject);
    procedure ExportSMSterpilih1Click(Sender: TObject);
  private
    { Private declarations }
    procedure SetTerkoneksi;
    procedure getInfo(buffer: string);
    function GoKonek: Boolean;
    procedure FilterDisplay();
    procedure HapusItem(kode: string);
    procedure SetPC(kode: string);
    procedure SetJenis(kode, jenis: string);
  public
    { Public declarations }
    function SendGetData(Teks, Batas: String): String;
    procedure BalasSMS;
    procedure ForwardSMS;
    procedure HapusSMS;
    procedure PindahSMS;
    procedure SimpanSMS;
    procedure BacaSMS;
    procedure SimpanPB;
    procedure BacaPB;
    procedure SimpanSetting;
    procedure BacaSetting;
    function getIndex: string;
  end;

Type
        SMSRec = Record
                Pengirim: String[20];
                Tanggal: String[20];
                Isi: String[160];
                Jenis: String[10];
        End;
        PhoneBookRec = Record
                Nama: String[30];
                Nomor: String[20];
                Jenis: String[10];
        End;

        tLokasiSMS = (LokasiPC, LokasiHP);
        tJenisSMS = (jBaru, jInbox, jDraft, jSent, jSemua);

const
        NamaFileSMS = 'sms.dat';
        NamaFilePB = 'phonebook.dat';

var
  fUtama: TfUtama;
  Item,
  List: TStrings;
  fSMS,
  fPB: file;
  ItemSMS: SMSRec;
  ItemPB: PhoneBookRec;
  LokasiDipilih: Set of tLokasiSMS;
  JenisSMS: tJenisSMS;
  CallInProgress: Boolean;

implementation

uses Unit2;

{$R *.dfm}

function TrimAll(t: string): string;
var s: string;
begin
        s := trim(t);
        s := copy(s, 2, length(s) - 2);
        result := s;
end;

function TfUtama.SendGetData;
var
        waktu: TDateTime;
begin
        ReadyState := False;
        BatasStr := Batas;
        Buffer := '';
        waktu := now;
        XComm1.SendString(Teks);
        while (Not ReadyState) and (SecondsBetween(waktu, Now) < 10)
         do Application.ProcessMessages;
        Result := Buffer;
end;

function TfUtama.GoKonek;
begin
     Konek := false;
     If Not fUtama.XComm1.Opened then 
        fUtama.XComm1.OpenDevice;

     if XComm1.SendString('ATE1'#13) and (XComm1.WaitForString(['OK'], 2000) <> -1) then
        Konek := True;
        
     Result := Konek;
end;

procedure TfUtama.getInfo;
var
    c,
    s: string;
    l: TListItem;
begin
     List.Text := buffer;
     s := List.Strings[1];
     l := LvPhone.Items.Add;
     
     if Pos('AT+CGMI', Buffer) > 0 then begin
        c := copy(Buffer, pos('AT+CGMI', Buffer) + 2, length(Buffer));
        Item.Text := c;
        l.Caption := 'Merk HP';
        l.SubItems.Add(Item.Strings[2]);
     end;
     if Pos('AT+GMM', Buffer) > 0 then begin
        c := copy(Buffer, pos('AT+GMM', Buffer) + 2, length(Buffer));
        Item.Text := c;
        l.Caption := 'Modem';
        l.SubItems.Add(Item.Strings[2]);
     end;
     if Pos('AT+CGSN', Buffer) > 0 then begin
        c := copy(Buffer, pos('AT+CGSN', Buffer) + 2, length(Buffer));
        Item.Text := c;
        l.Caption := 'I M E I';
        l.SubItems.Add(Item.Strings[2]);
     end;
     if Pos('+COPS:', Buffer) > 0 then begin
        c := copy(Buffer, pos('+COPS:', Buffer) + 7, length(Buffer));
        c := AnsiReplaceStr(c, ',', #13);
        Item.Text := c;
        l.Caption := 'Network Operator';
        l.SubItems.Add(TrimAll(Item.Strings[2]));
     end;
     if Pos('+CSCA:', Buffer) > 0 then begin
        c := copy(Buffer, pos('+CSCA:', Buffer) + 7, length(Buffer));
        c := AnsiReplaceStr(c, ',', #13);
        Item.Text := c;
        l.Caption := 'Service Center';
        SMSC := TrimAll(Item.Strings[0]);
        l.SubItems.Add(SMSC);
     end;
end;

procedure TfUtama.SetTerkoneksi;
begin
     If not Konek then
          Exit;

     LvPhone.Items.Clear;

     getInfo(SendGetData('AT+CGMI'#13, sOK));
     getInfo(SendGetData('AT+GMM'#13, sOK));
     getInfo(SendGetData('AT+CGSN'#13, sOK));
     getInfo(SendGetData('AT+COPS?'#13, sOK));
     getInfo(SendGetData('AT+CSCA?'#13, sOK));

     Timer1.Enabled := Konek;

     ListSMS.Items.Clear;
     BacaSMS;
     SpeedButton3.Caption := 'Diskonek';
     cbPort.Enabled := False;
     cbBaud.Enabled := False;
     SimpanSetting;

end;

procedure TfUtama.FormCreate(Sender: TObject);
var i : integer;
begin
     Item := TStringList.Create;
     List := TStringList.Create;
     Timer1.Enabled := False;

     cbPort.Items.Clear;
     for i := 1 to 30 do
        cbPort.Items.Add('COM' + IntToStr(i));
     cbPort.ItemIndex := 0;

     cbBaud.Items.Clear;
     cbBaud.Items.Add('9600');
     cbBaud.Items.Add('19200');
     cbBaud.Items.Add('57600');
     cbBaud.Items.Add('115200');
     cbBaud.Items.Add('128000');
     cbBaud.Items.Add('256000');
     cbBaud.ItemIndex := 0;
     
     cbSumber.ItemIndex := 0;
     cbJenisPB.ItemIndex := 0;

     LokasiDipilih := [LokasiPC, LokasiHP];
     JenisSMS := jSemua;
     CallInProgress := False;

     XComm1.BaudRate := brCustom;
     ListSMS.Items.Clear;
     BacaSMS;
     BacaPB;
     BacaSetting;
end;

procedure TfUtama.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     if XComm1.Opened then XComm1.CloseDevice;
     List.Free;
     Item.Free;
end;

procedure TfUtama.Timer1Timer(Sender: TObject);
var
    s, c: string;
begin
     if not Konek then exit;
     List.Text := SendGetData('AT+CIND?'+#13, sOk);
     s := List.Strings[2];
     c := copy(s, pos(':', s) + 2, length(s));
     c := AnsiReplaceStr(c, ',', #13#10);
     Item.Text := c;
     if c = '' then exit;
     if Item.Count < 2 then exit;

     pbSinyal.Position := StrToInt(Item.Strings[1]);
     pbBattery.Position := StrToInt(Item.Strings[0]);

     If Item.Strings[3] = '1' Then indSMSBaru.Color := clRed
        else indSMSBaru.Color := clSkyBlue;
     If Item.Strings[6] = '1' Then indSMSFull.Color := clRed
        else indSMSFull.Color := clSkyBlue;
     If Item.Strings[4] = '1' Then indPanggilan.Color := clRed
        else indPanggilan.Color := clSkyBlue;

end;

procedure TfUtama.TabPBookChange(Sender: TObject);
begin
        lblSisa.Caption := IntToStr(160 - length(txtPesan.Text));
        lblSMS.Caption := '';
end;

procedure TfUtama.txtPesanChange(Sender: TObject);
begin
        lblSisa.Caption := IntToStr(160 - length(txtPesan.Text));
end;

procedure TfUtama.BalasSMS;
var
    l: TListItem;
begin
    l := lvSMS.Selected;
    if l <> nil then begin
        txtNomor.Text := l.Caption;
        txtPesan.Text := l.SubItems[1];
        TabSheet4.Show;
        txtPesan.SetFocus;
    end;
end;

procedure TfUtama.ForwardSMS;
var
    l: TListItem;
begin
    l := lvSMS.Selected;
    if l <> nil then begin
        txtNomor.Text := '';
        txtPesan.Text := l.SubItems[1];
        TabSheet4.Show;
        txtNomor.SetFocus;
    end;
end;

procedure TfUtama.HapusItem;
var
    i: integer;
begin
        for i := ListSMS.Items.Count - 1 downto 0 do
                if ListSMS.Items.Item[i].SubItems[5] = kode then begin
                        ListSMS.Items.Item[i].Delete;
                        exit;
                end;
end;

procedure TfUtama.SetPC;
var
    i: integer;
begin
        for i := ListSMS.Items.Count - 1 downto 0 do
                if ListSMS.Items.Item[i].SubItems[5] = kode then begin
                        ListSMS.Items.Item[i].SubItems[2] := 'PC';
                        exit;
                end;
end;

procedure TfUtama.SetJenis;
var
    i: integer;
begin
        for i := ListSMS.Items.Count - 1 downto 0 do
                if ListSMS.Items.Item[i].SubItems[5] = kode then begin
                        ListSMS.Items.Item[i].SubItems[3] := Jenis;
                        exit;
                end;
end;

procedure TfUtama.HapusSMS;
var
    i: integer;
    l: TListItem;
    s,
    n: string;
begin
    if not Konek then begin
                ShowMessage('Belum terkoneksi ke HP');
                exit;
    end;

    Timer1.Enabled := False;
    for i := lvSMS.Items.Count - 1 downto 0 do begin
        l := lvSMS.Items.Item[i];
        if (l <> nil) and (l.Selected) then begin
            If l.SubItems[2] = 'PC' Then begin
                HapusItem(l.SubItems[5]);
                l.Delete;
            end
            else begin
                    n := l.SubItems[4];
                    s := SendGetData('AT+CMGD=' + n + #13, sOK);
                    if Pos(sOK, s) > 0 then begin
                         HapusItem(l.SubItems[5]);
                         l.Delete;
                    end;
            end;
        end;
    end;
    SimpanSMS;
    Timer1.Enabled := True;
end;

procedure TfUtama.VrHyperButton10Click(Sender: TObject);
var
    l: TListItem;
begin
    l := lvPBook.Selected;
    if l <> nil then begin
        txtNomor.Text := l.SubItems[0];
        txtPesan.Text := '';
        TabSheet4.Show;
    end;
end;

procedure TfUtama.PindahSMS;
var
    i: integer;
    l: TListItem;
    s,
    n: string;
begin
    if not Konek then begin
                ShowMessage('Belum terkoneksi ke HP');
                exit;
    end;

    Timer1.Enabled := False;
    prgbar2.Max := lvSMS.Items.Count - 1;
    prgbar2.Min := 0;
    prgbar2.Position := 0;
    prgbar2.Visible := True;
    for i := lvSMS.Items.Count - 1 downto 0 do begin
        l := lvSMS.Items.Item[i];
        if (l <> nil) and (l.Selected) then begin
                if l.SubItems[2] = 'Phone' then begin
                    n := l.SubItems[4];
                    s := SendGetData('AT+CMGD=' + n + #13, sOK);
                    if Pos(sOK, s) > 0 then begin
                            l.SubItems[2] := 'PC';
                            SetPC(l.SubItems[5]);
                    end;
                end;
        end;
        prgbar2.Position := (lvSMS.Items.Count - i) - 1;
    end;
    SimpanSMS;
    prgbar2.Visible := False;
    Timer1.Enabled := True;
end;

procedure TfUtama.SimpanSMS;
var
    i: integer;
    l: TListItem;
begin
        AssignFile(fSMS, NamaFileSMS);
        Rewrite(fSMS, 1);
        for i := 0 to ListSMS.Items.Count - 1 do begin
                l := ListSMS.Items.Item[i];
                if (l.SubItems[2] = 'PC') then begin
                        ItemSMS.Pengirim := l.Caption;
                        ItemSMS.Tanggal := l.SubItems[0];
                        ItemSMS.Isi := l.SubItems[1];
                        ItemSMS.Jenis := l.SubItems[3];
                        BlockWrite(fSMS, ItemSMS, SizeOf(ItemSMS));
                end;
        end;
        CloseFile(fSMS);
end;

procedure TfUtama.BacaSMS;
var
    i: integer;
    l: TListItem;
begin
        If Not FileExists(NamaFileSMS) Then Exit;
        AssignFile(fSMS, NamaFileSMS);
        Reset(fSMS, 1);
        While Not EOF(fSMS) do begin
                BlockRead(fSMS, ItemSMS, SizeOf(ItemSMS), i);
                l := ListSMS.Items.Add;
                l.Caption := ItemSMS.Pengirim;
                l.SubItems.Add(ItemSMS.Tanggal);
                l.SubItems.Add(ItemSMS.Isi);
                l.SubItems.Add('PC');
                l.SubItems.Add(ItemSMS.Jenis);
                l.SubItems.Add('0');
                l.SubItems.Add(getIndex);
        end;
        CloseFile(fSMS);
        FilterDisplay;
end;

procedure TfUtama.SimpanPB;
var
    i: integer;
    l: TListItem;
begin
        AssignFile(fPB, NamaFilePB);
        Rewrite(fPB, 1);
        for i := 0 to lvPBook.Items.Count - 1 do begin
                l := lvPBook.Items.Item[i];
                ItemPB.Nama := l.Caption;
                ItemPB.Nomor := l.SubItems[0];
                ItemPB.Jenis := l.SubItems[1];
                BlockWrite(fPB, ItemPB, SizeOf(ItemPB));
        end;
        CloseFile(fPB);
end;

procedure TfUtama.BacaPB;
var
    i: integer;
    l: TListItem;
begin
        If Not FileExists(NamaFilePB) Then Exit;
        lvPBook.Items.Clear;
        AssignFile(fPB, NamaFilePB);
        Reset(fPB, 1);
        While Not EOF(fPB) do begin
                BlockRead(fPB, ItemPB, SizeOf(ItemPB), i);
                l := lvPBook.Items.Add;
                l.Caption := ItemPB.Nama;
                l.SubItems.Add(ItemPB.Nomor);
                l.SubItems.Add(ItemPB.Jenis);
        end;
        CloseFile(fPB);
end;

procedure TfUtama.FormShow(Sender: TObject);
begin
        TabSheet1.Show;
end;

procedure TfUtama.lvSMSSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
        lblSMS.Caption := Item.SubItems[1];
end;

procedure TfUtama.PilihSemua1Click(Sender: TObject);
var
        i : integer;
begin
        for i := 0 to lvSMS.Items.Count - 1 do
                lvSMS.Items[i].Selected := True;
end;

procedure TfUtama.TidakPilihSemua1Click(Sender: TObject);
var
        i : integer;
begin
        for i := 0 to lvSMS.Items.Count - 1 do
                lvSMS.Items[i].Selected := False;
end;

procedure TfUtama.BalasSMS1Click(Sender: TObject);
begin
        BalasSMS;
end;

procedure TfUtama.ForwardSMS1Click(Sender: TObject);
begin
        ForwardSMS;
end;

procedure TfUtama.HapusSMS1Click(Sender: TObject);
begin
        HapusSMS;
end;

procedure TfUtama.PindahkePC1Click(Sender: TObject);
begin
        PindahSMS;
end;

procedure TfUtama.KirimSMS1Click(Sender: TObject);
var
    l: TListItem;
begin
    l := lvPBook.Selected;
    if l <> nil then begin
        txtNomor.Text := l.SubItems[0];
        txtPesan.Text := '';
        TabSheet4.Show;
        txtPesan.SetFocus;
    end;
end;

procedure TfUtama.CopyNomorkeClipboard1Click(Sender: TObject);
var
    l: TListItem;
begin
    l := lvSMS.Selected;
    if l <> nil then 
        Clipboard.AsText := l.Caption;
end;

procedure TfUtama.CopyTanggalkeClipboard1Click(Sender: TObject);
var
    l: TListItem;
begin
    l := lvSMS.Selected;
    if l <> nil then
        Clipboard.AsText := l.SubItems[0];
end;

procedure TfUtama.CopyPesankeClipboard1Click(Sender: TObject);
var
    l: TListItem;
begin
    l := lvSMS.Selected;
    if l <> nil then
        Clipboard.AsText := l.SubItems[1];
end;

procedure TfUtama.SpeedButton3Click(Sender: TObject);
begin
    if Konek then begin
        Timer1.Enabled := false;
        XComm1.CloseDevice;
        SpeedButton3.Caption := 'Konek';
        Konek := False;
        cbPort.Enabled := True;
        cbBaud.Enabled := True;
        pbSinyal.Position := 0;
        pbBattery.Position := 0;
    end
    else begin
        XComm1.BaudValue := StrToInt(cbBaud.Text);
        XComm1.DeviceName := cbPort.Text;
        If Not GoKonek Then
                ShowMessage('Gagal membuka port')
        else
                SetTerkoneksi;
    end;
end;

procedure TfUtama.SpeedButton4Click(Sender: TObject);
begin
        fAbout.ShowModal;
end;

procedure TfUtama.SpeedButton5Click(Sender: TObject);
begin
        Close;
end;

procedure TfUtama.SpeedButton6Click(Sender: TObject);
begin
        if not Konek then begin
                ShowMessage('Belum terkoneksi ke HP');
                exit;
        end;
        Timer1.Enabled := False;
        lblSMS.Caption := '';
        ListSMS.Items.Clear;
        SpeedButton6.Enabled := false;
        CekSMS();
        BacaSMS;
        SpeedButton6.Enabled := True;
        Timer1.Enabled := True;
end;

procedure TfUtama.SpeedButton7Click(Sender: TObject);
var c : string;
    i : integer;
    a,
    l: TListItem;
begin
        if txtNomor.Text = '' then begin
                ShowMessage('Nomor harus diisikan');
                exit;
        end;
        if not Konek then begin
                ShowMessage('Belum terkoneksi ke HP');
                exit;
        end;
        Timer1.Enabled := False;
        c := AnsiReplaceStr(txtNomor.Text, ',', #13#10);
        Item.Text := c;
        for i := 0 to Item.Count - 1 do begin
           c := trim(Item.Strings[i]);
           if (KirimSMS(c, txtPesan.Text)) then
           begin
                ShowMessage('Pesan sukses dikirim ke ' + c);
                l := ListSMS.Items.Add;
                l.Caption := c;
                l.SubItems.Add(DateTimeToStr(Now));
                l.SubItems.Add(txtPesan.Text);
                l.SubItems.Add('PC');
                l.SubItems.Add('Terkirim');
                l.SubItems.Add('0');
                l.SubItems.Add(getIndex);
                a := lvSMS.Items.Add;
                a.Caption := l.Caption;
                a.SubItems := l.SubItems;
           end
           else
                ShowMessage('Pesan gagal dikirim ke ' + c);
        end;
        SimpanSMS;
        FilterDisplay;
        Timer1.Enabled := True;
end;

procedure TfUtama.SpeedButton8Click(Sender: TObject);
begin
        txtNomor.Text := '';
        txtPesan.Text := '';
end;

procedure TfUtama.SpeedButton9Click(Sender: TObject);
var
   PDU: string;
   nomer,
   Tujuan,
   isi,
   s: string;
   a,
   l: TListItem;
begin
        if not Konek then begin
                ShowMessage('Belum terkoneksi ke HP');
                exit;
        end;
        
        Tujuan := txtNomor.Text;
        isi := txtPesan.Text;

        Timer1.Enabled := False;
        PDU := ConvertText('','',Tujuan,'','','',isi);
        s := SendGetData('AT+CMGW=' + inttostr(lkirim) + #13, '>');
        s := SendGetData(PDU + #$1A, sOK);

        if (pos(sOK, s) > 0) then begin
                l := ListSMS.Items.Add;
                l.Caption := Tujuan;
                l.SubItems.Add(DateTimeToStr(Now));
                l.SubItems.Add(isi);

                nomer := copy(s, 8, length(s));
                l.SubItems.Add('Phone');
                l.SubItems.Add('Terkirim');
                l.SubItems.Add(nomer);
                l.SubItems.Add(getIndex);
                a := lvSMS.Items.Add;
                a.Caption := l.Caption;
                a.SubItems := l.SubItems;
                ShowMessage('SMS tersimpan');
        end
        else
                ShowMessage('SMS tidak tersimpan');
        FilterDisplay;
        Timer1.Enabled := True;
end;

procedure TfUtama.SpeedButton10Click(Sender: TObject);
var
    l: TListItem;
    s, c: string;
    i, j,
    l1, l2,
    p1, p2 : integer;
begin
        if not Konek then begin
                ShowMessage('Belum terkoneksi ke HP');
                exit;
        end;
        
        lvPBook.Items.Clear;
        s := SendGetData('AT+CPBS=' + arSumber[cbJenisPB.itemindex]+#13, sOK);
        if Pos(sOK, s) = 0 then begin
                ShowMessage('Tidak dapat memilih media ' + cbJenisPB.Text);
                exit;
        end;

        s := SendGetData('AT+CPBR=?'+#13, sOK);
        if Pos(sOK, s) = 0 then begin
                ShowMessage('Tidak dapat membaca buku kontak');
                exit;
        end;

        p1 := pos('(', s) + 1;
        p2 := pos(')', s);
        c := copy(s, p1, p2 - p1);
        p1 := pos('-', c);
        if p1 = 0 Then exit;

        Timer1.Enabled := False;
        l1 := StrToInt(copy(c, 1, p1 - 1));
        l2 := StrToInt(copy(c, p1 + 1, length(c)));
        prgbar.Min := l1;
        prgbar.Max := l2;        
        prgbar.Visible := true;
        j := 0;
        for i := l1 to l2 do begin
                prgbar.Position := i;
                s := SendGetData('AT+CPBR=' + IntToStr(i)+#13, sOK);
                p1 := pos(':', s) + 2;
                s := Copy(s, p1, length(s));
                List.Text := AnsiReplaceStr(s, ',', #13#10);
                If List.Count > 3 then begin
                        l := lvPBook.Items.Add;
                        l.Caption := TrimAll(List.Strings[3]);
                        l.SubItems.Add(TrimAll(List.Strings[1]));
                        l.SubItems.Add(cbJenisPB.Text);
                        Inc(j);
                end;
        end;
        prgbar.Visible := false;
        SimpanPB;
        ShowMessage(IntToStr(j) + ' phonebook terbaca'); 
        Timer1.Enabled := True;
end;

procedure TfUtama.XComm1Data(Sender: TObject; const Received: Cardinal);
var data : string;
begin
        XComm1.ReadString(data);
        Buffer := Buffer + data;
        If (Not ReadyState) And (Pos(BatasStr, Buffer) > 0) Then Begin
                ReadyState := True;
        End;
end;

procedure TfUtama.SimpanSetting;
var
    Reg : TRegistry;
begin
  Reg := TRegistry.Create;
  try
    if Reg.OpenKey('\Software\BengkelProgram.com\HPApp', True) then
   begin
      Reg.WriteInteger('BaudRate', cbBaud.ItemIndex);
      Reg.WriteInteger('Port', cbPort.ItemIndex);
      Reg.CloseKey;
    end;
  finally
    Reg.Free;
    inherited;
  end;
end;

procedure TfUtama.BacaSetting;
var
    Reg : TRegistry;
begin
  Reg := TRegistry.Create;
  try
    if Reg.OpenKey('\Software\BengkelProgram.com\HPApp', True) then
   begin
      if Reg.ValueExists('BaudRate') then
        cbBaud.ItemIndex := Reg.ReadInteger('BaudRate')
      else
        cbBaud.ItemIndex := 0;
      if Reg.ValueExists('Port') then
        cbPort.ItemIndex := Reg.ReadInteger('Port')
      else
        cbPort.ItemIndex := 0;
      Reg.CloseKey;
    end;
  finally
    Reg.Free;
    inherited;
  end;
end;

procedure TfUtama.LokasidiPCClick(Sender: TObject);
begin
        LokasidiPC.Checked := Not LokasidiPC.Checked;
        If LokasidiPC.Checked Then
                LokasiDipilih := LokasiDipilih + [LokasiPC]
        Else
                LokasiDipilih := LokasiDipilih - [LokasiPC];
        FilterDisplay;
end;

procedure TfUtama.LokasidiHPClick(Sender: TObject);
begin
        LokasidiHP.Checked := Not LokasidiHP.Checked;
        If LokasidiHP.Checked Then
                LokasiDipilih := LokasiDipilih + [LokasiHP]
        Else
                LokasiDipilih := LokasiDipilih - [LokasiHP];
        FilterDisplay;
end;

procedure TfUtama.FilterDisplay();
var
    i: integer;
    a,
    l: TListItem;
begin
        lvSMS.Items.Clear;
        for i := 0 to ListSMS.Items.Count - 1 do begin
                l := ListSMS.Items.Item[i];
                if ((l.SubItems[2] = 'PC') and (LokasiPC in LokasiDipilih)) or
                   ((l.SubItems[2] = 'Phone') and (LokasiHP in LokasiDipilih)) then
                if (l.SubItems[3] = arJenisSMS[Ord(JenisSMS)]) or (JenisSMS = jSemua) then
                begin
                        a := lvSMS.Items.Add;
                        a.Caption := l.Caption;
                        a.SubItems := l.SubItems;
                end;
        end;
end;

procedure TfUtama.Semua1Click(Sender: TObject);
begin
        Semua1.Checked := True;
        JenisSMS := jSemua;
        FilterDisplay;
end;

procedure TfUtama.Baru1Click(Sender: TObject);
begin
        Baru1.Checked := True;
        JenisSMS := jBaru;
        FilterDisplay;
end;

procedure TfUtama.Inbox1Click(Sender: TObject);
begin
        Inbox1.Checked := True;
        JenisSMS := jInbox;
        FilterDisplay;
end;

procedure TfUtama.Draft1Click(Sender: TObject);
begin
        Draft1.Checked := True;
        JenisSMS := jDraft;
        FilterDisplay;
end;

procedure TfUtama.Terkirim1Click(Sender: TObject);
begin
        Terkirim1.Checked := True;
        JenisSMS := jSent;
        FilterDisplay;
end;

procedure TfUtama.Baru2Click(Sender: TObject);
var
    d,
    i: integer;
    l: TListItem;
    j: string;
begin
    d := 0;
    Timer1.Enabled := False;
    j := TMenuItem(Sender).Caption;
    j := AnsiReplaceStr(j, '&', '');
    for i := lvSMS.Items.Count - 1 downto 0 do begin
        l := lvSMS.Items.Item[i];
        if (l <> nil) and (l.Selected) then begin
            If l.SubItems[2] = 'PC' Then begin
                SetJenis(l.SubItems[5], j);
                l.SubItems[3] := j;
            end;
            Inc(d);
        end;
    end;
    If d = 0 Then Begin
        l := lvSMS.Selected;
        if (l <> nil) then begin
            If l.SubItems[2] = 'PC' Then begin
                SetJenis(l.SubItems[5], j);
                l.SubItems[3] := j;
            end;
        end;
    End;
    SimpanSMS;
    Timer1.Enabled := True;
end;

function TfUtama.getIndex;
var n, c: Integer;

begin
        if (ListSMS.Items.Count < 1) then
          Result := '1'
        else
        if (ListSMS.Items.Count < 2) then
          Result := '2'
        else begin
                Val(ListSMS.Items.Item[ListSMS.Items.Count - 2].SubItems[5], n, c);
                if c = 0 then
                        Result := IntToStr(n + 1)
                else
                        Result := '1';
        end;
end;

procedure TfUtama.SpeedButton1Click(Sender: TObject);
begin
        if not Konek then begin
                ShowMessage('Belum terkoneksi ke HP');
                exit;
        end;

        if TButton(Sender).Tag = 2 then begin
                SendGetData('ATH'#13, sOK);
        end
        else begin
                if txtNomorCall.Text = '' then begin
                        ShowMessage('Nomor tujuan belum diisikan');
                        exit;
                end;

                SendGetData('AT&FE0'#13, sOK);
                SendGetData('ATD ' + txtNomorCall.Text + ';'#13, sOK);
        end;
end;

procedure TfUtama.Panggil1Click(Sender: TObject);
var
    l: TListItem;
begin
    l := lvPBook.Selected;
    if l <> nil then begin
        txtNomorCall.Text := l.SubItems[0];
        TabSheet5.Show;
        txtNomorCall.SetFocus;
    end;end;

procedure TfUtama.ExportSMSterpilih1Click(Sender: TObject);
var
    d,
    i: integer;
    l: TListItem;
    f: TextFile;
begin
    if not SaveDialog1.Execute then exit;
     
    d := 0;
    Timer1.Enabled := False;
    prgbar2.Max := lvSMS.Items.Count - 1;
    prgbar2.Min := 0;
    prgbar2.Position := 0;
    prgbar2.Visible := True;
    AssignFile(f, SaveDialog1.FileName);
    Rewrite(f);
    for i := 0 to lvSMS.Items.Count - 1 do begin
        l := lvSMS.Items.Item[i];
        if (l <> nil) and (l.Selected) then begin
                Writeln(f, l.Caption+#9+l.Subitems[0]+#9+l.Subitems[1]+#9+l.Subitems[3]+#9);
                Inc(d);
        end;
        prgbar2.Position := i;
    end;
    If d = 0 Then Begin
        l := lvSMS.Selected;
        if (l <> nil) then begin
                Writeln(f, l.Caption+#8);
        end;
    End;
    CloseFile(f);
    prgbar2.Visible := False;
    Timer1.Enabled := True;
end;

end.
